/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.ActionSequence;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Argument;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml13.foundation.data_types.ActionExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.IterationExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.ObjectSetExpression;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Action</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getRecurrence
 * <em>Recurrence</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getTarget
 * <em>Target</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#isIsAsynchronous
 * <em>Is Asynchronous</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getScript
 * <em>Script</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getActualArgument
 * <em>Actual Argument</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getActionSequence
 * <em>Action Sequence</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getStimulus
 * <em>Stimulus</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getState1
 * <em>State1</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getState2
 * <em>State2</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getTransition
 * <em>Transition</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getState3
 * <em>State3</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.ActionImpl#getMessage
 * <em>Message</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class ActionImpl extends ModelElementImpl implements Action {
	/**
	 * The cached value of the '{@link #getRecurrence() <em>Recurrence</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRecurrence()
	 * @generated
	 * @ordered
	 */
	protected IterationExpression recurrence = null;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected ObjectSetExpression target = null;

	/**
	 * The default value of the '{@link #isIsAsynchronous()
	 * <em>Is Asynchronous</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #isIsAsynchronous()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ASYNCHRONOUS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsAsynchronous()
	 * <em>Is Asynchronous</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #isIsAsynchronous()
	 * @generated
	 * @ordered
	 */
	protected boolean isAsynchronous = IS_ASYNCHRONOUS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getScript() <em>Script</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getScript()
	 * @generated
	 * @ordered
	 */
	protected ActionExpression script = null;

	/**
	 * The cached value of the '{@link #getActualArgument()
	 * <em>Actual Argument</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getActualArgument()
	 * @generated
	 * @ordered
	 */
	protected EList actualArgument = null;

	/**
	 * The cached value of the '{@link #getStimulus() <em>Stimulus</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus = null;

	/**
	 * The cached value of the '{@link #getMessage() <em>Message</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage()
	 * @generated
	 * @ordered
	 */
	protected EList message = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getAction();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public IterationExpression getRecurrence() {
		return recurrence;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetRecurrence(IterationExpression newRecurrence, NotificationChain msgs) {
		IterationExpression oldRecurrence = recurrence;
		recurrence = newRecurrence;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__RECURRENCE, oldRecurrence, newRecurrence);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setRecurrence(IterationExpression newRecurrence) {
		if (newRecurrence != recurrence) {
			NotificationChain msgs = null;
			if (recurrence != null)
				msgs = ((InternalEObject) recurrence).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__RECURRENCE, null, msgs);
			if (newRecurrence != null)
				msgs = ((InternalEObject) newRecurrence).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__RECURRENCE, null, msgs);
			msgs = basicSetRecurrence(newRecurrence, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__RECURRENCE, newRecurrence, newRecurrence));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ObjectSetExpression getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTarget(ObjectSetExpression newTarget, NotificationChain msgs) {
		ObjectSetExpression oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__TARGET, oldTarget, newTarget);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTarget(ObjectSetExpression newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject) target).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__TARGET, null, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject) newTarget).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__TARGET, null, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__TARGET, newTarget, newTarget));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsAsynchronous() {
		return isAsynchronous;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsAsynchronous(boolean newIsAsynchronous) {
		boolean oldIsAsynchronous = isAsynchronous;
		isAsynchronous = newIsAsynchronous;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__IS_ASYNCHRONOUS, oldIsAsynchronous, isAsynchronous));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActionExpression getScript() {
		return script;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetScript(ActionExpression newScript, NotificationChain msgs) {
		ActionExpression oldScript = script;
		script = newScript;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__SCRIPT, oldScript, newScript);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setScript(ActionExpression newScript) {
		if (newScript != script) {
			NotificationChain msgs = null;
			if (script != null)
				msgs = ((InternalEObject) script).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__SCRIPT, null, msgs);
			if (newScript != null)
				msgs = ((InternalEObject) newScript).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_behaviorPackage.ACTION__SCRIPT, null, msgs);
			msgs = basicSetScript(newScript, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__SCRIPT, newScript, newScript));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getActualArgument() {
		if (actualArgument == null) {
			actualArgument = new EObjectContainmentWithInverseEList(Argument.class, this, Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT, Common_behaviorPackage.ARGUMENT__ACTION);
		}
		return actualArgument;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActionSequence getActionSequence() {
		if (eContainerFeatureID != Common_behaviorPackage.ACTION__ACTION_SEQUENCE)
			return null;
		return (ActionSequence) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setActionSequence(ActionSequence newActionSequence) {
		if (newActionSequence != eContainer || (eContainerFeatureID != Common_behaviorPackage.ACTION__ACTION_SEQUENCE && newActionSequence != null)) {
			if (EcoreUtil.isAncestor(this, newActionSequence))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActionSequence != null)
				msgs = ((InternalEObject) newActionSequence).eInverseAdd(this, Common_behaviorPackage.ACTION_SEQUENCE__ACTION, ActionSequence.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newActionSequence, Common_behaviorPackage.ACTION__ACTION_SEQUENCE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__ACTION_SEQUENCE, newActionSequence, newActionSequence));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus() {
		if (stimulus == null) {
			stimulus = new EObjectWithInverseResolvingEList(Stimulus.class, this, Common_behaviorPackage.ACTION__STIMULUS, Common_behaviorPackage.STIMULUS__DISPATCH_ACTION);
		}
		return stimulus;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public State getState1() {
		if (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE1)
			return null;
		return (State) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setState1(State newState1) {
		if (newState1 != eContainer || (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE1 && newState1 != null)) {
			if (EcoreUtil.isAncestor(this, newState1))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newState1 != null)
				msgs = ((InternalEObject) newState1).eInverseAdd(this, State_machinesPackage.STATE__ENTRY, State.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newState1, Common_behaviorPackage.ACTION__STATE1, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__STATE1, newState1, newState1));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public State getState2() {
		if (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE2)
			return null;
		return (State) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setState2(State newState2) {
		if (newState2 != eContainer || (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE2 && newState2 != null)) {
			if (EcoreUtil.isAncestor(this, newState2))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newState2 != null)
				msgs = ((InternalEObject) newState2).eInverseAdd(this, State_machinesPackage.STATE__EXIT, State.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newState2, Common_behaviorPackage.ACTION__STATE2, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__STATE2, newState2, newState2));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Transition getTransition() {
		if (eContainerFeatureID != Common_behaviorPackage.ACTION__TRANSITION)
			return null;
		return (Transition) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTransition(Transition newTransition) {
		if (newTransition != eContainer || (eContainerFeatureID != Common_behaviorPackage.ACTION__TRANSITION && newTransition != null)) {
			if (EcoreUtil.isAncestor(this, newTransition))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newTransition != null)
				msgs = ((InternalEObject) newTransition).eInverseAdd(this, State_machinesPackage.TRANSITION__EFFECT, Transition.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newTransition, Common_behaviorPackage.ACTION__TRANSITION, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__TRANSITION, newTransition, newTransition));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public State getState3() {
		if (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE3)
			return null;
		return (State) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setState3(State newState3) {
		if (newState3 != eContainer || (eContainerFeatureID != Common_behaviorPackage.ACTION__STATE3 && newState3 != null)) {
			if (EcoreUtil.isAncestor(this, newState3))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newState3 != null)
				msgs = ((InternalEObject) newState3).eInverseAdd(this, State_machinesPackage.STATE__DO_ACTIVITY, State.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newState3, Common_behaviorPackage.ACTION__STATE3, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ACTION__STATE3, newState3, newState3));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage() {
		if (message == null) {
			message = new EObjectWithInverseResolvingEList(Message.class, this, Common_behaviorPackage.ACTION__MESSAGE, CollaborationsPackage.MESSAGE__ACTION);
		}
		return message;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__NAMESPACE, msgs);
			case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Common_behaviorPackage.ACTION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
				return ((InternalEList) getActualArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__ACTION_SEQUENCE, msgs);
			case Common_behaviorPackage.ACTION__STIMULUS:
				return ((InternalEList) getStimulus()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__STATE1:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__STATE1, msgs);
			case Common_behaviorPackage.ACTION__STATE2:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__STATE2, msgs);
			case Common_behaviorPackage.ACTION__TRANSITION:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__TRANSITION, msgs);
			case Common_behaviorPackage.ACTION__STATE3:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ACTION__STATE3, msgs);
			case Common_behaviorPackage.ACTION__MESSAGE:
				return ((InternalEList) getMessage()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__NAMESPACE, msgs);
			case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__BINDING:
				return basicSetBinding(null, msgs);
			case Common_behaviorPackage.ACTION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Common_behaviorPackage.ACTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__RECURRENCE:
				return basicSetRecurrence(null, msgs);
			case Common_behaviorPackage.ACTION__TARGET:
				return basicSetTarget(null, msgs);
			case Common_behaviorPackage.ACTION__SCRIPT:
				return basicSetScript(null, msgs);
			case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
				return ((InternalEList) getActualArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__ACTION_SEQUENCE, msgs);
			case Common_behaviorPackage.ACTION__STIMULUS:
				return ((InternalEList) getStimulus()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ACTION__STATE1:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__STATE1, msgs);
			case Common_behaviorPackage.ACTION__STATE2:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__STATE2, msgs);
			case Common_behaviorPackage.ACTION__TRANSITION:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__TRANSITION, msgs);
			case Common_behaviorPackage.ACTION__STATE3:
				return eBasicSetContainer(null, Common_behaviorPackage.ACTION__STATE3, msgs);
			case Common_behaviorPackage.ACTION__MESSAGE:
				return ((InternalEList) getMessage()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.ACTION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.ACTION_SEQUENCE__ACTION, ActionSequence.class, msgs);
			case Common_behaviorPackage.ACTION__STATE1:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE__ENTRY, State.class, msgs);
			case Common_behaviorPackage.ACTION__STATE2:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE__EXIT, State.class, msgs);
			case Common_behaviorPackage.ACTION__TRANSITION:
				return eContainer.eInverseRemove(this, State_machinesPackage.TRANSITION__EFFECT, Transition.class, msgs);
			case Common_behaviorPackage.ACTION__STATE3:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE__DO_ACTIVITY, State.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.ACTION__NAME:
			return getName();
		case Common_behaviorPackage.ACTION__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.ACTION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.ACTION__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.ACTION__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.ACTION__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.ACTION__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.ACTION__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Common_behaviorPackage.ACTION__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Common_behaviorPackage.ACTION__COMMENT:
			return getComment();
		case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Common_behaviorPackage.ACTION__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Common_behaviorPackage.ACTION__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.ACTION__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.ACTION__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.ACTION__PARTITION:
			return getPartition();
		case Common_behaviorPackage.ACTION__RECURRENCE:
			return getRecurrence();
		case Common_behaviorPackage.ACTION__TARGET:
			return getTarget();
		case Common_behaviorPackage.ACTION__IS_ASYNCHRONOUS:
			return isIsAsynchronous() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.ACTION__SCRIPT:
			return getScript();
		case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
			return getActualArgument();
		case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
			return getActionSequence();
		case Common_behaviorPackage.ACTION__STIMULUS:
			return getStimulus();
		case Common_behaviorPackage.ACTION__STATE1:
			return getState1();
		case Common_behaviorPackage.ACTION__STATE2:
			return getState2();
		case Common_behaviorPackage.ACTION__TRANSITION:
			return getTransition();
		case Common_behaviorPackage.ACTION__STATE3:
			return getState3();
		case Common_behaviorPackage.ACTION__MESSAGE:
			return getMessage();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.ACTION__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Common_behaviorPackage.ACTION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.ACTION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__BINDING:
			setBinding((Binding) newValue);
			return;
		case Common_behaviorPackage.ACTION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Common_behaviorPackage.ACTION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__RECURRENCE:
			setRecurrence((IterationExpression) newValue);
			return;
		case Common_behaviorPackage.ACTION__TARGET:
			setTarget((ObjectSetExpression) newValue);
			return;
		case Common_behaviorPackage.ACTION__IS_ASYNCHRONOUS:
			setIsAsynchronous(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.ACTION__SCRIPT:
			setScript((ActionExpression) newValue);
			return;
		case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
			getActualArgument().clear();
			getActualArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
			setActionSequence((ActionSequence) newValue);
			return;
		case Common_behaviorPackage.ACTION__STIMULUS:
			getStimulus().clear();
			getStimulus().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ACTION__STATE1:
			setState1((State) newValue);
			return;
		case Common_behaviorPackage.ACTION__STATE2:
			setState2((State) newValue);
			return;
		case Common_behaviorPackage.ACTION__TRANSITION:
			setTransition((Transition) newValue);
			return;
		case Common_behaviorPackage.ACTION__STATE3:
			setState3((State) newValue);
			return;
		case Common_behaviorPackage.ACTION__MESSAGE:
			getMessage().clear();
			getMessage().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.ACTION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.ACTION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.ACTION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.ACTION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.ACTION__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.ACTION__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.ACTION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.ACTION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Common_behaviorPackage.ACTION__BINDING:
			setBinding((Binding) null);
			return;
		case Common_behaviorPackage.ACTION__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Common_behaviorPackage.ACTION__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Common_behaviorPackage.ACTION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.ACTION__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.ACTION__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.ACTION__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.ACTION__RECURRENCE:
			setRecurrence((IterationExpression) null);
			return;
		case Common_behaviorPackage.ACTION__TARGET:
			setTarget((ObjectSetExpression) null);
			return;
		case Common_behaviorPackage.ACTION__IS_ASYNCHRONOUS:
			setIsAsynchronous(IS_ASYNCHRONOUS_EDEFAULT);
			return;
		case Common_behaviorPackage.ACTION__SCRIPT:
			setScript((ActionExpression) null);
			return;
		case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
			getActualArgument().clear();
			return;
		case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
			setActionSequence((ActionSequence) null);
			return;
		case Common_behaviorPackage.ACTION__STIMULUS:
			getStimulus().clear();
			return;
		case Common_behaviorPackage.ACTION__STATE1:
			setState1((State) null);
			return;
		case Common_behaviorPackage.ACTION__STATE2:
			setState2((State) null);
			return;
		case Common_behaviorPackage.ACTION__TRANSITION:
			setTransition((Transition) null);
			return;
		case Common_behaviorPackage.ACTION__STATE3:
			setState3((State) null);
			return;
		case Common_behaviorPackage.ACTION__MESSAGE:
			getMessage().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ACTION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.ACTION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.ACTION__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Common_behaviorPackage.ACTION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.ACTION__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.ACTION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.ACTION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.ACTION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.ACTION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.ACTION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.ACTION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Common_behaviorPackage.ACTION__BINDING:
			return binding != null;
		case Common_behaviorPackage.ACTION__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.ACTION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.ACTION__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Common_behaviorPackage.ACTION__STEREOTYPE:
			return stereotype != null;
		case Common_behaviorPackage.ACTION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.ACTION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.ACTION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.ACTION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.ACTION__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.ACTION__RECURRENCE:
			return recurrence != null;
		case Common_behaviorPackage.ACTION__TARGET:
			return target != null;
		case Common_behaviorPackage.ACTION__IS_ASYNCHRONOUS:
			return isAsynchronous != IS_ASYNCHRONOUS_EDEFAULT;
		case Common_behaviorPackage.ACTION__SCRIPT:
			return script != null;
		case Common_behaviorPackage.ACTION__ACTUAL_ARGUMENT:
			return actualArgument != null && !actualArgument.isEmpty();
		case Common_behaviorPackage.ACTION__ACTION_SEQUENCE:
			return getActionSequence() != null;
		case Common_behaviorPackage.ACTION__STIMULUS:
			return stimulus != null && !stimulus.isEmpty();
		case Common_behaviorPackage.ACTION__STATE1:
			return getState1() != null;
		case Common_behaviorPackage.ACTION__STATE2:
			return getState2() != null;
		case Common_behaviorPackage.ACTION__TRANSITION:
			return getTransition() != null;
		case Common_behaviorPackage.ACTION__STATE3:
			return getState3() != null;
		case Common_behaviorPackage.ACTION__MESSAGE:
			return message != null && !message.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isAsynchronous: "); //$NON-NLS-1$
		result.append(isAsynchronous);
		result.append(')');
		return result.toString();
	}

} // ActionImpl
