/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.state_machines;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml13.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>State Vertex</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getContainer
 * <em>Container</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getOutgoing
 * <em>Outgoing</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getIncoming
 * <em>Incoming</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getStateVertex()
 * @model abstract="true"
 * @generated
 */
public interface StateVertex extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Container</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.CompositeState#getSubvertex
	 * <em>Subvertex</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Container</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Container</em>' container reference.
	 * @see #setContainer(CompositeState)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getStateVertex_Container()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.CompositeState#getSubvertex
	 * @model opposite="subvertex"
	 * @generated
	 */
	CompositeState getContainer();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getContainer
	 * <em>Container</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Container</em>' container
	 *            reference.
	 * @see #getContainer()
	 * @generated
	 */
	void setContainer(CompositeState value);

	/**
	 * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getSource
	 * <em>Source</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Outgoing</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getStateVertex_Outgoing()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getSource
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition"
	 *        opposite="source"
	 * @generated
	 */
	EList getOutgoing();

	/**
	 * Returns the value of the '<em><b>Incoming</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTarget
	 * <em>Target</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Incoming</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getStateVertex_Incoming()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTarget
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition"
	 *        opposite="target"
	 * @generated
	 */
	EList getIncoming();

} // StateVertex
