/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Classifier</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getFeature <em>
 * Feature</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getParticipant
 * <em>Participant</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getPowertypeRange
 * <em>Powertype Range</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getInstance <em>
 * Instance</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getCreateAction
 * <em>Create Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getClassifierInState
 * <em>Classifier In State</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.Classifier#getObjectFlowState
 * <em>Object Flow State</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier()
 * @model abstract="true"
 * @generated
 */
public interface Classifier extends GeneralizableElement, Namespace {
	/**
	 * Returns the value of the '<em><b>Feature</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Feature}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Feature#getOwner
	 * <em>Owner</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Feature</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Feature</em>' containment reference
	 *         list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_Feature()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Feature#getOwner
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Feature"
	 *        opposite="owner" containment="true"
	 * @generated
	 */
	EList getFeature();

	/**
	 * Returns the value of the '<em><b>Participant</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.AssociationEnd}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.AssociationEnd#getSpecification
	 * <em>Specification</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Participant</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Participant</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_Participant()
	 * @see fr.obeo.acceleo.uml13.foundation.core.AssociationEnd#getSpecification
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.AssociationEnd"
	 *        opposite="specification"
	 * @generated
	 */
	EList getParticipant();

	/**
	 * Returns the value of the '<em><b>Powertype Range</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Generalization}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Generalization#getPowertype
	 * <em>Powertype</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Powertype Range</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Powertype Range</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_PowertypeRange()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Generalization#getPowertype
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Generalization"
	 *        opposite="powertype"
	 * @generated
	 */
	EList getPowertypeRange();

	/**
	 * Returns the value of the '<em><b>Instance</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getClassifier
	 * <em>Classifier</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Instance</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_Instance()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance#getClassifier
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance"
	 *        opposite="classifier"
	 * @generated
	 */
	EList getInstance();

	/**
	 * Returns the value of the '<em><b>Create Action</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction#getInstantiation
	 * <em>Instantiation</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Create Action</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Create Action</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_CreateAction()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction#getInstantiation
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction"
	 *        opposite="instantiation"
	 * @generated
	 */
	EList getCreateAction();

	/**
	 * Returns the value of the '<em><b>Classifier In State</b></em>'
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState#getType
	 * <em>Type</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Classifier In State</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Classifier In State</em>' reference
	 *         list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_ClassifierInState()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState#getType
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState"
	 *        opposite="type"
	 * @generated
	 */
	EList getClassifierInState();

	/**
	 * Returns the value of the '<em><b>Object Flow State</b></em>'
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState#getType
	 * <em>Type</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object Flow State</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Object Flow State</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getClassifier_ObjectFlowState()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState#getType
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState"
	 *        opposite="type"
	 * @generated
	 */
	EList getObjectFlowState();

} // Classifier
