/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.impl.spec;

import java.util.List;

import org.eclipse.emf.ecore.EObject;

/**
 * Implement this interface for recursive call checking during generation of
 * statements block.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface IRecursiveCheckable extends IEvaluable {
	/**
	 * Tell if the EObject has already been visited during the generation.
	 * 
	 * @param eObj
	 *            the EObject to check
	 * @return true is the EObject has been used for generation
	 */
	boolean isRecursive(EObject eObj);

	/**
	 * Getter for the list of generated EObjects.
	 * 
	 * @return true is the EObject has been used for generation
	 */
	List<EObject> getVisitedEObjects();
}
