package org.acceleo.gen;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.acceleo.engine.IModel;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.xmi.impl.EcoreResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

public class EcoreModel implements IModel{

	private String nsURI;
	
	private Resource resource;
	
	public EcoreModel(ResourceSet resourceSet, URI ecoreURI, URI modelURI) throws Exception{
		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("ecore", new EcoreResourceFactoryImpl());
		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("xmi", new XMIResourceFactoryImpl());
		Resource ECoreresource = resourceSet.getResource(ecoreURI, true);
		if(ECoreresource.getContents().size() > 0){
			Object result = ECoreresource.getContents().get(0);
			
			List ePackageList = new ArrayList();
			ePackageList.add(result);
			while(ePackageList.size() > 0){
				Object current = ePackageList.remove(0);
				if(current instanceof EPackage){
					EPackage ePackage = (EPackage)current;
					nsURI = ePackage.getNsURI();
					EPackage.Registry.INSTANCE.put(nsURI, ePackage);
					for(Iterator itSubPackage = ePackage.getESubpackages().iterator(); itSubPackage.hasNext();){
						EPackage subPackage = (EPackage)itSubPackage.next();
						ePackageList.add(subPackage);
					}
				}
			}
		}
		resource = resourceSet.getResource(modelURI, true);
	}
	
	public String getNsURI() {
		return nsURI;
	}

	public List<EObject> getRoots() {
		List<EObject> ret = new ArrayList<EObject>();
		for (int i = 0; i < resource.getContents().size(); ++i) {
			ret.add(resource.getContents().get(i));
		}
		return ret;
	}

}
