/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.gen.extension.phantom;

import fr.obeo.acceleo.gen.template.eval.SyncElement;

import org.acceleo.gen.phantom.AbstractSyncPhantom;

/**
 * The interface should be implemented to provide new phantom extension.
 * 
 * @author Yvan LUSSAUD <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface IPhantomExtension {

	/**
	 * Returns SyncPhantom.
	 * 
	 * @return SyncPhantom
	 */
	AbstractSyncPhantom getSyncPhantom();

	/**
	 * Returns SyncElement.
	 * 
	 * @return SyncElement
	 */
	SyncElement getSyncElement();

	/**
	 * Returns project nature.
	 * 
	 * @return project nature
	 */
	String getProjectNature();
}
